/*
	Lesson 13 Subqueries
	Correlated Subqueries
*/


SELECT order_num
FROM orderitems
WHERE prod_id = 'TNT2';

go

SELECT cust_id
FROM orders
WHERE order_num IN (20005,20007);

go


SELECT cust_id
FROM orders
WHERE order_num IN (SELECT order_num
                    FROM orderitems
                    WHERE prod_id = 'TNT2');

go

SELECT cust_name, cust_contact
FROM customers
WHERE cust_id IN (10001,10004);

go

SELECT cust_name, cust_contact
FROM customers
WHERE cust_id IN (SELECT cust_id
                  FROM orders
                  WHERE order_num IN (SELECT order_num
                                      FROM orderitems
                                      WHERE prod_id = 'TNT2'));

go

SELECT Count(*) AS orders
FROM orders
WHERE cust_id = 10001;

go

-- Correlated Subquery
SELECT cust_name,
       cust_state,
      (SELECT Count(*)
       FROM orders
       WHERE orders.cust_id = customers.cust_id) AS orders
FROM customers
ORDER BY cust_name;


go

SELECT cust_name,
       cust_state,
      (SELECT Count(*)
       FROM orders
       WHERE cust_id = cust_id) AS orders
FROM customers
ORDER BY cust_name;

go

SELECT cust_id, cust_name
FROM customers
WHERE cust_id IN (SELECT cust_id
                  FROM orders
                  WHERE DateDiff(month, order_date, '2016-09-01') = 0 AND customers.cust_id = orders.cust_id);

go

SELECT cust_id, cust_name
FROM customers
WHERE EXISTS (SELECT *
              FROM orders
              WHERE DateDiff(month, order_date, '2016-09-01') = 0 AND customers.cust_id = orders.cust_id);