/*
	Lesson 21 Using Views

	CREATE VIEW

*/

SELECT cust_name, cust_contact
FROM customers, orders, orderitems
WHERE customers.cust_id = orders.cust_id
AND orderitems.order_num = orders.order_num
AND prod_id = 'TNT2';

go

CREATE VIEW productcustomers AS
SELECT cust_name, cust_contact, prod_id
FROM customers, orders, orderitems
WHERE customers.cust_id = orders.cust_id
AND orderitems.order_num = orders.order_num;

go

SELECT cust_name, cust_contact
FROM productcustomers
WHERE prod_id = 'TNT2';

go

SELECT RTrim(vend_name) + ' (' + RTrim(vend_country) + ')'
AS vend_title
FROM vendors
ORDER BY vend_name;

go

CREATE VIEW vendorlocations AS
SELECT RTrim(vend_name) + ' (' + RTrim(vend_country) + ')'
AS vend_title
FROM vendors;

go

SELECT *
FROM vendorlocations
ORDER BY vend_title;

go

CREATE VIEW customeremaillist AS
SELECT cust_id, cust_name, cust_email
FROM customers
WHERE cust_email IS NOT NULL;

go

SELECT *
FROM customeremaillist;

go

SELECT prod_id,
quantity,
item_price,
quantity*item_price AS expanded_price
FROM orderitems
WHERE order_num = 20005;

go

CREATE VIEW orderitemsexpanded AS
SELECT order_num,
prod_id,
quantity,
item_price,
quantity*item_price AS expanded_price
FROM orderitems;

go

SELECT *
FROM orderitemsexpanded
WHERE order_num = 20005;


