/*
	Lesson 23 Working with Stored Procedures

	CREATE PROC
*/

CREATE PROCEDURE productpricing AS
	BEGIN
		SELECT Avg(prod_price) AS priceaverage
		FROM products;
	END;

go

exec productpricing

go

DROP PROCEDURE productpricing;

go

CREATE PROCEDURE productpricing
@price_min MONEY OUTPUT,
@price_max MONEY OUTPUT,
@price_avg MONEY OUTPUT
AS
	BEGIN
		SELECT @price_min = Min(prod_price)
		FROM products;
		SELECT @price_max = Max(prod_price)
		FROM products;
		SELECT @price_avg = Avg(prod_price)
		FROM products;
	END;

go

DECLARE @cheap MONEY
DECLARE @expensive MONEY
DECLARE @average MONEY
EXECUTE productpricing @cheap OUTPUT, @expensive OUTPUT, @average OUTPUT

SELECT @cheap AS Cheap;
SELECT @cheap, @expensive, @average;

go

CREATE PROCEDURE ordertotal
	@order_num INT,
	@order_total MONEY OUTPUT
AS
	BEGIN
		SELECT @order_total = Sum(item_price*quantity)
		FROM orderitems
		WHERE order_num = @order_num;
	END;

go

DECLARE @order_total MONEY
EXECUTE ordertotal 20005, @order_total OUTPUT
SELECT @order_total

go

DROP PROC ordertotal
go


CREATE PROCEDURE ordertotal
@order_num INT,
@taxable BIT,
@order_total MONEY OUTPUT
AS
BEGIN
	-- Declare variable for total
	DECLARE @total MONEY;
	-- Declare tax percentage
	DECLARE @taxrate INT;
	-- Set tax rate (adjust as needed)
	SET @taxrate = 6;
	-- Get the order total
	SELECT @total = Sum(item_price*quantity)
	FROM orderitems
	WHERE order_num = @order_num
	-- Is this taxable?
	IF @taxable = 1
		-- Yes, so add taxrate to the total
		SET @total=@total+(@total/100*@taxrate);
		-- And finally, save to output variable
		SELECT @order_total = @total;
END;		

go

DECLARE @order_total MONEY
EXECUTE ordertotal 20005, 0, @order_total OUTPUT
SELECT @order_total

go


DECLARE @order_total MONEY
EXECUTE ordertotal 20005, 1, @order_total OUTPUT
SELECT @order_total