/*
	Lesson 25 Using Triggers

	CREATE TRIGGER
	AFTER | INSTEAD OF
	INSERT | UDATE | DELETE

	ENABLE TRIGGER
	DISABLE TRIGGER
	DROP TRIIGER

	sp_helptrigger

*/

CREATE TRIGGER newproduct_trigger ON products
AFTER INSERT
AS
SELECT 'Product added';

go

DROP TRIGGER newproduct_trigger;

go

DISABLE TRIGGER newproduct_trigger ON products;

go

sp_helptrigger products

go

CREATE TRIGGER neworder_trigger ON orders
AFTER INSERT
AS
SELECT @@IDENTITY AS order_num;

go

INSERT INTO orders(order_date, cust_id)
VALUES(GetDate(), 10001);

go

CREATE TRIGGER deleteorder_trigger ON orders
AFTER DELETE
AS
BEGIN
	INSERT INTO orders_archive(order_num, order_date, cust_id)
	SELECT order_num, order_date, cust_id FROM DELETED;
END;

go

CREATE TRIGGER vendor_trigger ON vendors
AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE vendors
	SET vend_state=Upper(vend_state)
	WHERE vend_id IN (SELECT vend_id FROM INSERTED);
END;
