/*
	Lesson 27 Working with XML and JSON

*/


SELECT vend_id, RTrim(vend_name) AS vend_name
FROM vendors
ORDER BY vend_name
FOR XML AUTO;

go

SELECT cust_name, orders.order_num, products.prod_id,
prod_name
FROM customers, orders, orderitems, products
WHERE customers.cust_id=orders.cust_id
AND orders.order_num=orderitems.order_num
AND orderitems.prod_id=products.prod_id
ORDER BY cust_name, orders.order_num, products.prod_id
FOR XML AUTO;

go

SELECT vend_id AS id, RTrim(vend_name) AS name
FROM vendors
ORDER BY vend_name
FOR XML RAW('vendor'), ROOT('vendors'), ELEMENTS;

go

SELECT 1 AS tag,
NULL AS parent,
vend_id AS [vendor!1!id],
RTrim(vend_name) AS [vendor!1!name!ELEMENT]
FROM vendors
ORDER BY vend_name
FOR XML EXPLICIT, ROOT('vendors');

go

CREATE TABLE MyXMLTable
(
id INT NOT NULL IDENTITY(1,1) PRIMARY KEY,
data XML NOT NULL
);

go

INSERT INTO MyXMLTable(data)
VALUES(
'<state abbrev="CA">
<city name="Los Angeles" />
<city name="San Francisco" />
</state>');
INSERT INTO MyXMLTable(data)
VALUES(
'<state abbrev="IL">
<city name="Chicago" />
</state>');
INSERT INTO MyXMLTable(data)
VALUES(
'<state abbrev="NY">
<city name="New York" />
</state>');

go

INSERT INTO MyXMLTable(data)
VALUES(
Cast('<state abbrev="CA">
<city name="Los Angeles" />
<city name="San Francisco" />
</state>' AS XML));
INSERT INTO MyXMLTable(data)
VALUES(
Cast('<state abbrev="IL">
<city name="Chicago" />
</state>' AS XML));
INSERT INTO MyXMLTable(data)
VALUES(
Cast ('<state abbrev="NY">
<city name="New York" />
</state>' AS XML));

go

SELECT data.query('/state/city')
FROM MyXMLTable;

go

SELECT *
FROM MyXMLTable
WHERE data.exist('/state/city[@name="Chicago"]') = 1;

go

SELECT cust_id, RTrim(cust_name) as cname
FROM customers
FOR JSON AUTO;

go

SELECT cust_id,
RTrim(cust_name) as [info.cust_name],
RTrim(cust_contact) as [info.cust_contact]
FROM customers
FOR JSON PATH;